/* RelayMail.p 
 * Relays mail pulled from the relay account to the subscription list
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header$" NO-UNDO.

DEF VAR lConfFileName      AS CHARACTER NO-UNDO.
DEF VAR lRelayAccount      AS CHARACTER NO-UNDO.
DEF VAR lRelayPassword     AS CHARACTER NO-UNDO.
DEF VAR lRelayServer       AS CHARACTER NO-UNDO.
DEF VAR lDeleteServerMail  AS CHARACTER NO-UNDO.

/* Pick up where the configuration file is at */

ASSIGN lConfFileName = OS-GETENV("CONFFILE").

/* Determine the account that acts as the relay */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Mail",
                  INPUT "RelayAccount",
                  OUTPUT lRelayAccount).

/* Pull in the password for that account */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Mail",
                  INPUT "RelayPassword",
                  OUTPUT lRelayPassword).

/* Where is the account at */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Mail",
                  INPUT "RelayServer",
                  OUTPUT lRelayServer).

/* Do we delete the mail after pulling it? */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Mail",
                  INPUT "DeleteServerMail",
                  OUTPUT lDeleteServerMail).

/* Pull in the mail */

RUN PullMail.p (INPUT lRelayAccount,
                INPUT lRelayPassword,
                INPUT lRelayServer,
                INPUT lDeleteServerMail).

/* Send them out */

RUN bat_SendMessage.p.

