/* SendEZine.p
 *
 * Written by Scott Auge
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/ezine/src/RCS/SendFile.p,v 1.1 2001/09/27 18:07:33 sauge Exp $" NO-UNDO.

DEF VAR lEZineFile           AS CHARACTER NO-UNDO.
DEF VAR lEZineFileName       AS CHARACTER NO-UNDO.
DEF VAR lConfFileName        AS CHARACTER NO-UNDO.
DEF VAR lValue               AS CHARACTER NO-UNDO.
DEF VAR lLogFile             AS CHARACTER NO-UNDO.
DEF VAR lCommand             AS CHARACTER NO-UNDO.
DEF VAR lMailHub             AS CHARACTER NO-UNDO.
DEF VAR lThrottle            AS INTEGER NO-UNDO.
DEF VAR lPause               AS CHARACTER NO-UNDO.
DEF VAR lFromAddress         AS CHARACTER NO-UNDO.
DEF VAR oSuccessful          AS CHARACTER NO-UNDO.
DEF VAR vMessage             AS CHARACTER NO-UNDO.

/* Determine the file we are sending out */

ASSIGN lEZineFile = OS-GETENV("EZINEISSUE").
ASSIGN lEZineFileName = ENTRY(NUM-ENTRIES(lEZineFile, "/"),lEZineFile,"/").

/* Pick up where the configuration file is at */

ASSIGN lConfFileName = OS-GETENV("CONFFILE").

/* Where to denote how we're doing */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Logging",
                  INPUT "LogFile",
                  OUTPUT lLogFile).

IF lLogFile <> "" THEN OUTPUT TO VALUE(lLogFile).

/* Determine the name of the mailing list */

ASSIGN lConfFileName = OS-GETENV("CONFFILE").

PUT UNFORMATTED "CONFIG FILE:" lConfFileName SKIP.

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "List",
                  INPUT "ListName",
                  OUTPUT lValue).

PUT UNFORMATTED "MAIL LIST NAME:" lValue SKIP.

/* Determine who the mail is from in case a system account is running */
/* this program.                                                      */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Mail",
                  INPUT "FromAddress",
                  OUTPUT lFromAddress).

/* Determine the throttle between emails cuz a large list can over tax a */
/* server's resources.                                                   */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Command",
                  INPUT "Pause",
                  OUTPUT lPause).

ASSIGN lThrottle = INTEGER (lPause).

/* Mail hub we use to send the mail with. */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Mail",
                  INPUT "MailHub",
                  OUTPUT lMailHub).

/* Determine if list exists in DB */

FIND MailList NO-LOCK
WHERE MailList.Name = lValue
NO-ERROR.

IF NOT AVAILABLE MailList THEN RETURN.

/* Send out the issue to the community */

FOR EACH MailListMember OF MailList NO-LOCK:

  FIND Person OF MailListMember NO-LOCK NO-ERROR.

  IF NOT AVAILABLE Person THEN NEXT.

  FIND Contact OF Person NO-LOCK.

  IF NOT AVAILABLE Contact THEN NEXT.

/*
  RUN bat_smtpmail.p (INPUT lMailHub,
                      INPUT Contact.Email,
                      INPUT lFromAddress,
                      INPUT "",
                      INPUT lEZineFileName + ":type=application/msword:filetype=doc",
                      INPUT lEZineFile,
                      INPUT "Progress E-Zine",
                      INPUT "",
                      INPUT "type=multipart/mixed:filetype=doc",
                      INPUT "File",
                      OUTPUT oSuccessful,
                      OUTPUT vMessage).

*/
  ASSIGN lCommand = "mpack -s ~"Progress E-Zine~" " 
                  + lEZineFile + " " + Contact.Email.

  UNIX VALUE(lCommand).
  PUT UNFORMATTED lCommand SKIP.

  PAUSE lThrottle.  /* Sleep to not overload the internet connection */

END. /* FOR EACH MailListMember OF MailList */

PUT UNFORMATTED "DONE" SKIP.

OUTPUT CLOSE.

