/* DO NOT EDIT - THIS IS A GENERATED FILE */

{sga_util.i}
 /* <!--WSS */
/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2001 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/ezine/src/RCS/Subscribe.html,v 1.1 2001/09/20 19:55:54 sauge Exp $" NO-UNDO.

DEF VAR lFirstName          AS CHARACTER NO-UNDO.
DEF VAR lLastName           AS CHARACTER NO-UNDO.
DEF VAR lEmailAddress       AS CHARACTER NO-UNDO.
DEF VAR lPassword1          AS CHARACTER NO-UNDO.
DEF VAR lPassword2          AS CHARACTER NO-UNDO.

DEF VAR lError              AS CHARACTER NO-UNDO.
DEF VAR lPersonID           AS CHARACTER NO-UNDO.
DEF VAR lContactID          AS CHARACTER NO-UNDO.
DEF VAR lMailListID         AS CHARACTER NO-UNDO.
DEF VAR lListMemberID       AS CHARACTER NO-UNDO.
DEF VAR lSecUserID          AS CHARACTER NO-UNDO.

DEF VAR lConfFileName       AS CHARACTER NO-UNDO.
DEF VAR lValue              AS CHARACTER NO-UNDO.

{Error.i}
{AlertBox.i}
{Relocate.i}
{history.i}

/* Pull in values from the EZineHome.html page. */

ASSIGN 
lFirstName     = GET-VALUE("FirstName")
lLastName      = GET-VALUE("LastName")
lEmailAddress  = GET-VALUE("Email")
lPassword1     = GET-VALUE("Password1")
lPassword2     = GET-VALUE("Password2").

/* Determine if the passwords are proper */

IF lPassword1 <> lPassword2 THEN DO:

  AlertBox ("Your passwords do not match!").
  History(-1).
  RETURN.

END. /* IF lPassword1 <> lPassword2 */

/* Determine name of the mailing list and if it exists.  If not, prep the */
/* data for integrity.                                                    */

ASSIGN lConfFileName = OS-GETENV("CONFFILE").

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "List",
                  INPUT "ListName",
                  OUTPUT lValue).

/* Determine if the Mail List record exists, if not, go ahead and create it */

FIND MailList NO-LOCK
WHERE MailList.Name = lValue
NO-ERROR.

IF NOT AVAILABLE MailList THEN DO:

  RUN records/maillist/CreateMailList.p (INPUT lValue,
                                         OUTPUT lMailListID, 
                                         OUTPUT lError).

  IF lError <> {&NOERROR} THEN DO:

    AlertBox ("MailList:" + lError).
    RETURN.

  END. /* IF lError <> {&NOERROR} */

END.  /* IF NOT AVAILABLE MailList */

ELSE ASSIGN lMailListID = MailList.MailListID.

/* Determine if this person is already in the mail list.  If so, we want */
/* to bail outta here.                                                   */

FIND FIRST Person NO-LOCK
WHERE Person.FirstName = lFirstName
  AND Person.LastName = lLastName
NO-ERROR.

IF AVAILABLE Person THEN DO:

  FIND FIRST MailListMember NO-LOCK
  WHERE MailListMember.MailListID = lMailListID
    AND MailListMember.PersonID = Person.PersonID
   NO-ERROR.

  IF AVAILABLE MailListMember THEN DO:

    AlertBox ("Your on here already!").

    RUN conf/inird.p (INPUT lConfFileName,
                      INPUT "Redirect",
                      INPUT "HomePage",
                      OUTPUT lValue).

    Relocate(lValue). 

    RETURN.

  END.
END.

/* Create a Contact record.  This is needed to link into the Person record */
/* as it is a relational child to the Person record.                       */

RUN records/contact/CreateContact.p (INPUT "",
                                     INPUT "",
                                     INPUT lEmailAddress,
                                     INPUT "",
                                     INPUT "",
                                     OUTPUT lContactID,
                                     OUTPUT lError).

IF lError <> {&NOERROR} THEN DO:

  AlertBox ("Contact:" + lError).
  RETURN.

END. /* IF lError <> {&NOERROR} */

/* Create the Person record.  This will be linked into the EZine Mailing */
/* list record.                                                          */

RUN records/person/CreatePerson.p (INPUT lFirstName,
                                   INPUT lLastName,
                                   INPUT "",
                                   INPUT lContactID,
                                   OUTPUT lPersonID,
                                   OUTPUT lError).

IF lError <> {&NOERROR} THEN DO:

  AlertBox ("Person:" + lError).
  RETURN.

END. /* IF lError <> {&NOERROR} */

/* Make this a secure user */

RUN records/secuser/CreateSecUser.p (INPUT lPersonID,
                                     INPUT lEmailAddress,
                                     INPUT lPassword1,
                                     INPUT "",
                                     OUTPUT lSecUserID,
                                     OUTPUT lError).

IF lError <> {&NOERROR} THEN DO:

  AlertBox ("SecUser:" + lError).
  RETURN.

END. /* IF lError <> {&NOERROR} */

/* Add the person to the Mailing List */

RUN records/maillist/CreateListMember.p (INPUT lMailListID,
                                         INPUT lPersonID,
                                         OUTPUT lListMemberID,
                                         OUTPUT lError).

IF lError <> {&NOERROR} THEN DO:

  AlertBox ("MailListMember:" + lError).
  RETURN.

END. /* IF lError <> {&NOERROR} */

/* Pull up the records for display */

FIND Contact NO-LOCK
WHERE Contact.ContactID = lContactID
NO-ERROR.

FIND Person NO-LOCK
WHERE Person.PersonID = lPersonID
NO-ERROR.

 /* --> */

PUT STREAM StdOut UNFORMATTED '<head>~n'.
PUT STREAM StdOut UNFORMATTED '<title>Subscribed to Progress E-Zine Magazine</title>~n'.
PUT STREAM StdOut UNFORMATTED '<meta http-equiv=~"Content-Type~" content=~"text/html; charset=iso-8859-1~">~n'.
PUT STREAM StdOut UNFORMATTED '</head>~n'.
PUT STREAM StdOut UNFORMATTED '<body bgcolor=~"#FFFFFF~">~n'.
PUT STREAM StdOut UNFORMATTED '<p align=~"center~">&nbsp;</p>~n'.
PUT STREAM StdOut UNFORMATTED '<p align=~"center~"><b><font size=~"5~" face=~"Times New Roman, Times, serif~">Congratulations! ~n'.
PUT STREAM StdOut UNFORMATTED '  </font></b></p>~n'.
PUT STREAM StdOut UNFORMATTED '<p align=~"center~"><b><font size=~"3~" face=~"Times New Roman, Times, serif~">You are ~n'.
PUT STREAM StdOut UNFORMATTED '  now subscribed to the Progress E-Zine List under the name</font></b></p>~n'.
PUT STREAM StdOut UNFORMATTED '<p align=~"center~"><b><font face=~"Times New Roman, Times, serif~" size=~"3~">' Person.FirstName ' ' Person.LastName ' ' Contact.Email '</font></b></p>~n'.
PUT STREAM StdOut UNFORMATTED '<p align=~"center~"><b><font face=~"Times New Roman, Times, serif~" size=~"3~">You need ~n'.
PUT STREAM StdOut UNFORMATTED '  not do anything more to receive the next issue of the E-Zine.</font></b></p>~n'.
PUT STREAM StdOut UNFORMATTED '<p align=~"center~"><b><font face=~"Times New Roman, Times, serif~" size=~"3~">Click ~n'.
PUT STREAM StdOut UNFORMATTED '  here for archives of the Progress E-Zine.</font></b></p>~n'.
PUT STREAM StdOut UNFORMATTED '</body>~n'.
PUT STREAM StdOut UNFORMATTED '</html>~n'.
