/* bat_sendmessage.p
 *
 * Written by Scott Auge
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/ezine/src/RCS/bat_SendMessage.p,v 1.1 2001/09/20 19:57:21 sauge Exp $" NO-UNDO.

DEF VAR lListName          AS CHARACTER NO-UNDO.
DEF VAR lConfFileName      AS CHARACTER NO-UNDO.
DEF VAR lMailHub           AS CHARACTER NO-UNDO.
DEF VAR lFromAddress       AS CHARACTER NO-UNDO.
DEF VAR oSuccessful        AS CHARACTER NO-UNDO.
DEF VAR vMessage           AS CHARACTER NO-UNDO.
DEF VAR lLogFile           AS CHARACTER NO-UNDO.
DEF VAR lPause             AS CHARACTER NO-UNDO.
DEF VAR lThrottle          AS INTEGER NO-UNDO.

/* Pick up where the configuration file is at */

ASSIGN lConfFileName = OS-GETENV("CONFFILE").

/* Determine the throttle between emails cuz a large list can over tax a */
/* server's resources.                                                   */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Command",
                  INPUT "Pause",
                  OUTPUT lPause).

ASSIGN lThrottle = INTEGER (lPause).

/* Determine Log File */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Logging",
                  INPUT "LogFile",
                  OUTPUT lLogFile).

OUTPUT TO VALUE(lLogFile).

/* Determine name of the mailing list and if it exists.  If not, prep the */
/* data for integrity.                                                    */


RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "List",
                  INPUT "ListName",
                  OUTPUT lListname).


FIND MailList NO-LOCK
WHERE MailList.Name = lListName
NO-ERROR.

/* Determine the Mail Hub we are sending this to */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Mail",
                  INPUT "MailHub",
                  OUTPUT lMailHub).

/* Determine who the mail is from in case a system account is running */
/* this program.                                                      */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Mail",
                  INPUT "FromAddress",
                  OUTPUT lFromAddress).
/* Look for emails ready to go */

FOR EACH Email EXCLUSIVE-LOCK
WHERE Email.ToAddress = lListName
  AND Email.State = "Send":

  /* Send email out to each member on the mail list */

  FOR EACH MailListMember OF MailList NO-LOCK:

    FIND Person OF MailListMember NO-LOCK NO-ERROR.

    FIND Contact OF Person NO-LOCK NO-ERROR.

    RUN bat_smtpmail.p (INPUT lMailHub,
                        INPUT Contact.Email,
                        INPUT lFromAddress,
                        INPUT "",
                        INPUT "",
                        INPUT "",
                        INPUT Email.Subject,
                        INPUT Email.Body,
                        INPUT "",
                        INPUT "",
                        OUTPUT oSuccessful,
                        OUTPUT vMessage).

    PAUSE lThrottle.

  END. /* FOR EACH MailListMember OF MailList */

  ASSIGN Email.State = "Sent".

END. /* FOR EACH Email */

