
/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2001 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


/* DO NOT EDIT - THIS IS A GENERATED FILE */

{sga_util.i}
 /* <!--WSS */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/ezine/src/RCS/ForgotPW2.p,v 1.1 2001/11/09 00:19:59 sauge Exp sauge $" NO-UNDO.

DEF VAR lEmail     AS CHARACTER NO-UNDO.
DEF VAR lMessage   AS CHARACTER NO-UNDO.
DEF VAR lPassword  AS CHARACTER NO-UNDO.

DEF VAR vMessage   AS CHARACTER NO-UNDO.
DEF VAR oSuccessful AS LOGICAL NO-UNDO.

{MakeID2.i}

/* Pull in data from ForgotPW1.html and generate a new password string */

ASSIGN 
lEmail = GET-VALUE("Email")
lPassword = MakeID2(10).

/* Determine if we can find the user as specified in the login.  This */
/* should be their email address.                                     */

FIND SecUser EXCLUSIVE-LOCK
WHERE SecUser.Login = lEmail
NO-ERROR.

IF NOT AVAILABLE SecUser THEN DO:
   /* --> */

PUT STREAM StdOut UNFORMATTED '  <html>~n'.
PUT STREAM StdOut UNFORMATTED '  <body>~n'.
PUT STREAM StdOut UNFORMATTED '  Cannot find your login ID... sorry!  Simply re-subscribe!~n'.
PUT STREAM StdOut UNFORMATTED '  </body>~n'.
PUT STREAM StdOut UNFORMATTED '  </html>~n'.   /* <!--WSS */
  RETURN.
END.  /* IF NOT AVAILABLE SecUser */

/* Since we found the user, assign their password to the new password */

ASSIGN SecUser.Password = lPassword.

/* Construct a message to the user so they have the new password */

ASSIGN
lMessage = "This is your new password to login into the subscription pages for"
         + " the Progress E-Zine: " + lPassword.

RUN bat_smtpmail.p (INPUT "localhost",
                    INPUT SecUser.Login,
                    INPUT "sauge@amduus.com",
                    INPUT "", /* "sauge@amduus.com", */
                    INPUT "",
                    INPUT "",
                    INPUT "New EZine Password",
                    INPUT lMessage,
                    INPUT "text/html",
                    INPUT "text/html",
                    
                    OUTPUT oSuccessful,
                    OUTPUT vMessage
                    ).

 /* --> */

PUT STREAM StdOut UNFORMATTED '<html>~n'.
PUT STREAM StdOut UNFORMATTED '<head>~n'.
PUT STREAM StdOut UNFORMATTED '<title>Generate New Password</title>~n'.
PUT STREAM StdOut UNFORMATTED '<meta http-equiv=~"Content-Type~" content=~"text/html; charset=iso-8859-1~">~n'.
PUT STREAM StdOut UNFORMATTED '</head>~n'.
PUT STREAM StdOut UNFORMATTED '<body bgcolor=~"#FFFFFF~">~n'.
PUT STREAM StdOut UNFORMATTED '<p>&nbsp;</p>~n'.
PUT STREAM StdOut UNFORMATTED '<p>&nbsp;</p>~n'.
PUT STREAM StdOut UNFORMATTED '<table width=~"70%~" border=~"1~" cellspacing=~"0~" align=~"center~">~n'.
PUT STREAM StdOut UNFORMATTED '  <tr>~n'.
PUT STREAM StdOut UNFORMATTED '    <td>~n'.
PUT STREAM StdOut UNFORMATTED '      <center>~n'.
PUT STREAM StdOut UNFORMATTED '        Your new password has been sent to ' lEmail ' ~n'.
PUT STREAM StdOut UNFORMATTED '      </center>~n'.
PUT STREAM StdOut UNFORMATTED '    </td>~n'.
PUT STREAM StdOut UNFORMATTED '  </tr>~n'.
PUT STREAM StdOut UNFORMATTED '  <tr>~n'.
PUT STREAM StdOut UNFORMATTED '    <td>~n'.
PUT STREAM StdOut UNFORMATTED '      <center>~n'.         /* <!--WSS */
        IF NOT oSuccessful THEN
         /* --> */

PUT STREAM StdOut UNFORMATTED '        ' vMessage '~n'.
PUT STREAM StdOut UNFORMATTED '      </center>~n'.
PUT STREAM StdOut UNFORMATTED '    </td>~n'.
PUT STREAM StdOut UNFORMATTED '  </tr>~n'.
PUT STREAM StdOut UNFORMATTED '</table>~n'.
PUT STREAM StdOut UNFORMATTED '<p align=~"center~"><a href=~"http://www.amduus.com~">Amduus Home Page</a></p>~n'.
PUT STREAM StdOut UNFORMATTED '</body>~n'.
PUT STREAM StdOut UNFORMATTED '</html>~n'.
