
/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2001 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


/* RelayMail.p 
 * Relays mail pulled from the relay account to the subscription list
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/ezine/src/RCS/RelayMail.p,v 1.1 2001/11/09 00:19:59 sauge Exp sauge $" NO-UNDO.

DEF VAR lConfFileName      AS CHARACTER NO-UNDO.
DEF VAR lRelayAccount      AS CHARACTER NO-UNDO.
DEF VAR lRelayPassword     AS CHARACTER NO-UNDO.
DEF VAR lRelayServer       AS CHARACTER NO-UNDO.
DEF VAR lDeleteServerMail  AS CHARACTER NO-UNDO.

/* Pick up where the configuration file is at */

ASSIGN lConfFileName = OS-GETENV("CONFFILE").

/* Determine the account that acts as the relay */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Mail",
                  INPUT "RelayAccount",
                  OUTPUT lRelayAccount).

/* Pull in the password for that account */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Mail",
                  INPUT "RelayPassword",
                  OUTPUT lRelayPassword).

/* Where is the account at */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Mail",
                  INPUT "RelayServer",
                  OUTPUT lRelayServer).

/* Do we delete the mail after pulling it? */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Mail",
                  INPUT "DeleteServerMail",
                  OUTPUT lDeleteServerMail).

/* Pull in the mail */

RUN PullMail.p (INPUT lRelayAccount,
                INPUT lRelayPassword,
                INPUT lRelayServer,
                INPUT lDeleteServerMail).

/* Send them out */

RUN bat_SendMessage.p.

