
/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2001 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


/* DO NOT EDIT - THIS IS A GENERATED FILE */

{sga_util.i}
 /* <!--WSS */

/* Send a message to the email list */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/ezine/src/RCS/SendMessage.p,v 1.1 2001/11/09 00:19:59 sauge Exp sauge $" NO-UNDO.

DEF VAR lFrom          AS CHARACTER NO-UNDO.
DEF VAR lSubject       AS CHARACTER NO-UNDO.
DEF VAR lMessage       AS CHARACTER NO-UNDO.

DEF VAR lMailListName  AS CHARACTER NO-UNDO.
DEF VAR lCommand       AS CHARACTER NO-UNDO.
DEF VAR lError         AS CHARACTER NO-UNDO.

DEF VAR lConfFileName  AS CHARACTER NO-UNDO.

{AlertBox.i}

/* Retrieve data from EZineEnterMessage.html */

ASSIGN
lSubject = GET-VALUE("Subject")
lFrom    = GET-VALUE("From")
lMessage = GET-VALUE("Message").

/* Determine name of the mailing list */

ASSIGN lConfFileName = OS-GETENV("CONFFILE").

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "List",
                  INPUT "ListName",
                  OUTPUT lMailListName).

FIND MailList NO-LOCK
WHERE MailList.Name = lMailListName
NO-ERROR.

IF NOT AVAILABLE MailList THEN DO:

  AlertBox("Cannot find record for Mail List Named " + lMailListName).
  RETURN.

END.  /* IF NOT AVAILABLE MailList */

/* Create a record because another process will be spawned to actually     */
/* send out the email.                                                     */

RUN records/email/CreateEmail.p (INPUT lFrom,
                                 INPUT lMailListName,
                                 INPUT lSubject,
                                 INPUT lMessage,
                                 OUTPUT lError).

/* Determine the script to run for the background process of sending mail. */
/* A script is run because large mailing lists will cause the web server   */
/* time out before the run is done.                                        */

RUN conf/inird.p (INPUT lConfFileName,
                  INPUT "Command",
                  INPUT "SendMail",
                  OUTPUT lCommand).

UNIX SILENT VALUE(lCommand).

 /* --> */

PUT STREAM StdOut UNFORMATTED '<html>~n'.
PUT STREAM StdOut UNFORMATTED '<head>~n'.
PUT STREAM StdOut UNFORMATTED '<title>Send a message</title>~n'.
PUT STREAM StdOut UNFORMATTED '<meta http-equiv=~"Content-Type~" content=~"text/html; charset=iso-8859-1~">~n'.
PUT STREAM StdOut UNFORMATTED '</head>~n'.
PUT STREAM StdOut UNFORMATTED '<body bgcolor=~"#FFFFFF~">~n'.
PUT STREAM StdOut UNFORMATTED 'Your message is being delivered to the mail list. <br>~n'.
PUT STREAM StdOut UNFORMATTED '' lCommand '~n'.
PUT STREAM StdOut UNFORMATTED '</body>~n'.
PUT STREAM StdOut UNFORMATTED '</html>~n'.
